#!/usr/bin/python2.7
#-*- coding: utf-8 -*-
from __future__ import print_function

import sys
from sys import *

#Minimal API for LC3 3-address instructions

class Instru3A:
    def __init__(self,ins,arg1,arg2,arg3):
        self.ins=ins
        self.arg1=arg1
        self.arg2=arg2
        self.arg3=arg3

    #print the instruction on the output.
    def printIns(self,stream):
        #an Instruction has at least two operands
        s=self.ins+' '+self.arg1
        if self.arg2 != '':
            s=s+' , '+self.arg2
            if self.arg3 != '':
                s=s+' , '+self.arg3
        print(s,file=stream)

class LC3Prog:
    def __init__(self):
        self._listIns=[]
        self._nbtmp = 0
        self._nblabel=0

    #all temps are prefixed by temp_
    def newtmp(self):
        self._nbtmp = self._nbtmp+1
        return 'temp_'+str(self._nbtmp)

    def newlabelWhile(self):
        self._nblabel = self._nblabel+1
        return ("l_while_begin_"+str(self._nblabel),"l_while_end_"+str(self._nblabel))

    def newlabelCond(self):
        self._nblabel = self._nblabel+1
        return ("l_cond_neg_"+str(self._nblabel),"l_cond_end_"+str(self._nblabel))

    #Minimal version - Not very clean. 
    def addLabel(self,s):
        self._listIns.append(Instru3A(s+':','','',''))
        
    #Same remark
    def addComment(self,s):
        self._listIns.append(Instru3A(";;"+s,'','',''))
        
    def addInstructionBR(self,s,label):
        self._listIns.append(Instru3A("BR"+s,str(label),'',''))

    def addInstructionGOTO(self,label):
        self._listIns.append(Instru3A("BR",str(label),'',''))
        
    def addInstructionNOT(self,dr,sr1):
        self._listIns.append(Instru3A("NOT",str(dr),str(sr1),''))
    
    def addInstructionADD(self,dr,sr1,sr2orimm7):
        self._listIns.append(Instru3A("ADD",str(dr),str(sr1),str(sr2orimm7)))

    def addInstructionAND(self,dr,sr1,sr2orimm7):
        self._listIns.append(Instru3A("AND",str(dr),str(sr1),str(sr2orimm7)))
    
    def printCode(self,filename):
        #dump generated code on stdout or file.
        output = open(filename, 'w') if filename else sys.stdout
        print(';;Automatically generated code',file=output)
        for i in self._listIns:
            i.printIns(output)
        if output is not sys.stdout:
            output.close()
