from MuLexer import MuLexer
from MuParser import MuParser
from MuVisitor import MuVisitor
from MyMuCodeGenVisitor import *

from antlr4 import*
from sys import *
from os import *

from antlr4.tree.Trees import Trees

def main():
    inputname=argv[1]
    input_s=FileStream(inputname)
    lexer = MuLexer(input_s)
    stream = CommonTokenStream(lexer)
    parser = MuParser(stream)
    tree=parser.prog();     
    
    (hd,rest)=path.splitext(inputname)
    output_name=hd+".asm"
    print("Code will be generated in file "+output_name)
    
    #Codegen Visitor, first argument is debug mode
    visitor3 = MyMuCodeGenVisitor(True,output_name,parser);
    #parser is there to provide basic PP for expressions.
    
    visitor3.visit(tree);

if __name__ == '__main__':
    main()

