from MuVisitor import MuVisitor
from MuParser import *
from math import *

#API for basic 3-@code generation
from APICodeLC3 import *
#Easy Pretty print
from antlr4.tree.Trees import Trees

class MyMuCodeGenVisitor(MuVisitor):
    
    def __init__(self,d,s,parser):
        self._outputname=s
        self._parser=parser
        self._debug=d
        self._memory=dict()
    #3-address code generation
        self._prog=LC3Prog()

    def printRegisterMap(self):
        print("--variables to register map--")
        for keys,values in self._memory.items():
            print(keys+'-->'+values)

    #code generation for expressions
    #TODO : int, bool constants, +,-,or,and, <,>,<=,>=
    
    def visitMultiplicativeExpr(self,ctx):
        raise Exception("Not Yet Implemented")
    
    
    #statements
    #TODO Assign, If, While
    
    def visitProgRule(self,ctx):
        self.visit(ctx.block())
        self._prog.printCode(self._outputname)
        self.printRegisterMap()

    def visitStatList(self,ctx):
    #each statement generates a comment in the generated code
        for stat in ctx.stat():
            self._prog.addComment(Trees.toStringTree(stat,None,self._parser))
            self.visit(stat)
                
    def visitAssignStat(self,ctx):
        if self._debug: #show how to use the PP
            print("assign statement, rightexpression is:")
            print(Trees.toStringTree(ctx.expr(),None,self._parser))
            #TBC
        


