#!/bin/bash

#LG, Oct 2016.
#finds all temporaries and replace (in place) into real registers
#aborts if there exists more than 8 temporaries.
#also adds .ORIG x3000 and .END 

if [ ! $# -eq 1 ]
then
    echo "One arg please"
    exit 1
else
    if [[ $1 == *.asm ]]
    then
	echo "Trying to test a 3-address file"
	nb=$(grep -c "temp_" $1)
	nb2=$(grep -c "temp_[0-9][0-9]" $1)
	if [ ! $nb -eq 0 ]
	then
	    echo "found temporaries, this is a valid LC3 - 3 address code"
	    #real job here
	    if [ $nb2 -le 7 ]
	    then
		echo "less than 8 temporaries, we can change into registers"
		sed -i '1i.ORIG X3000' $1
		sed -i -e 's/temp_/R/g' $1
		echo ".END" >> $1
		echo "$1 has been modified"
	    else
		echo "more than 8 registers, abort"
		exit 1
	    fi
	    
	else
	    echo "no temp, abort"
	    exit 1
	fi
    else
	echo "should be an asm file"
	exit 1
    fi
fi
